# openforcefield.typing.engines.smirnoff.parameters.AngleHandler.AngleType

class `openforcefield.typing.engines.smirnoff.parameters.AngleHandler.``AngleType`(**kwargs)

  A SMIRNOFF angle type.

  Warning

  This API is experimental and subject to change.

  Attributes
    smirks

  Methods

  `add_cosmetic_attribute`(self, attr_name, …) | Add a cosmetic attribute to this ParameterType object.
  `delete_cosmetic_attribute`(self, attr_name) | Delete a cosmetic attribute from this ParameterType object.
  `to_dict`(self[, discard_cosmetic_attributes]) | Convert this ParameterType object to dict.

  `__init__`(self, **kwargs)

    Create a ParameterType

    Parameters
      smirks str

        The SMIRKS match for the provided parameter type.

      allow_cosmetic_attributes bool optional. Default = False

        Whether to permit non-spec kwargs (“cosmetic attributes”). If True, non-spec kwargs will be stored as an attribute of this parameter which can be accessed and written out. Otherwise an exception will be raised.

  Methods

  `__init__`(self, \*\*kwargs) | Create a ParameterType
  `add_cosmetic_attribute`(self, attr_name, …) | Add a cosmetic attribute to this ParameterType object.
  `delete_cosmetic_attribute`(self, attr_name) | Delete a cosmetic attribute from this ParameterType object.
  `to_dict`(self[, discard_cosmetic_attributes]) | Convert this ParameterType object to dict.

  Attributes

  `smirks` |

  `add_cosmetic_attribute`(self, attr_name, attr_value)

    Add a cosmetic attribute to this ParameterType object. This attribute will not have a functional effect on the object in the Open Force Field toolkit, but can be written out during output.

    Parameters
      attr_name str

        Name of the attribute to define for this ParameterType object.

      attr_value str

        The value of the attribute to define for this ParameterType object.

  `delete_cosmetic_attribute`(self, attr_name)

    Delete a cosmetic attribute from this ParameterType object.

    Parameters
      attr_name str

        Name of the attribute to delete.

  `to_dict`(self, discard_cosmetic_attributes=False)

    Convert this ParameterType object to dict. A unit-bearing attribute (‘X’) will be converted to two dict entries, one ([‘X’] containing the unitless value, and another ([‘X_unit’]) containing a string representation of its unit.

    Parameters
      discard_cosmetic_attributes bool, optional. Default = False

        Whether to discard non-spec attributes of this ParameterType

    Returns
      smirnoff_dict dict

        The SMIRNOFF-compliant dict representation of this ParameterType object.

      output_units dict[str: simtk.unit.Unit]

        A mapping from each simtk.unit.Quanitity-valued ParameterType attribute to the unit it was converted to during serialization.